(function() {
  var stream;

  stream = require('stream');

  exports.take = function(base, n, done, dstat) {
    var ended, fin, rem, wrap, wrapread;
    rem = n;
    wrap = stream.Readable();
    ended = false;
    if (done != null) {
      wrap.once('end', done);
    }
    base.once('end', function() {
      ended = true;
      return fin();
    });
    fin = function() {
      wrap.push(null);
      return base.removeListener('readable', wrapread);
    };
    wrap._read = function(size) {
      var data;
      if (ended || rem <= 0) {
        return;
      }
      if (size != null) {
        size = Math.min(size, rem);
      } else {
        size = rem;
      }
      data = base.read(size);
      if (data == null) {
        data = base.read();
      }
      if (data != null) {
        rem -= data.length;
        wrap.push(data);
        if (typeof dstat === "function") {
          dstat(n - rem, n);
        }
        if (rem <= 0) {
          return fin();
        }
      }
    };
    wrapread = function() {
      return wrap._read();
    };
    base.on('readable', wrapread);
    return wrap;
  };

}).call(this);
